/**
 * 
 */
package find;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

import javax.swing.JFileChooser;

/**
 * @author Veikko Niemi 10.12.2008 9.42.32
 */
public class ReadFile {

    private BufferedReader luettava;
    private File file;

    public ReadFile() {
        String s = System.getProperty("file.separator");
        File in = new File("c:" + s + "java" + s + "eclipse" + s + "haaga-helia" + s + "src" + s + "ohjelmointi" + s + "osio4" + s + "tiedostot");
        File myy = new File(s + s + "myy" + s + "a0802123" + s + "Ohjelmointi_syksy_2008" +
                s + "osio4" + s + "src" + s + "ohjelmointi" + s + "osio4" + s + "tiedostot");
        if (myy.exists()) {
            in = myy;
        }
        askFile(in);
    }

    public ReadFile(File file) {

        setBufferedReader(file);
        this.file = file;
    }

    public ReadFile(ReadFile luettava) {
        this.luettava = luettava.luettava;
        this.file = luettava.file;
    }

    @Override
    public String toString() {
        String palauta = "";
        if (luettava != null && file != null) {
            int i = 1;
            String rivi = readNext();
            while (rivi != null) {
                palauta += i + ". " + rivi + "\n";
                i++;
                rivi = readNext();
            }
        }
        return palauta;
    }

    public BufferedReader getReader() {
        return luettava;
    }

    public File getFile() {
        return file;
    }

    public void setFile(File file) {
        this.file = file;
    }

    public void setReader(BufferedReader luettava) {
        this.luettava = luettava;
    }

    private void setBufferedReader(File file) {
//        boolean ok = false;
        try {
            this.luettava = new BufferedReader(new FileReader(file));
//            ok = true;            
        } catch (FileNotFoundException fnf) {
            System.err.println("Tiedostoa " + file + " ei löydy!\n" + fnf.getMessage());
            fnf.printStackTrace();

        } catch (Exception e) {
            System.err.println("Virhe tiedostoa " + file + " avattaessa!");
            e.printStackTrace();

        }
    }

    public File askFile(File cur) {
        JFileChooser jfc = new JFileChooser();
        File f = cur;
        if (cur.isDirectory() || !cur.exists()) {
            jfc.setCurrentDirectory(cur);
            System.out.println("Default folder " + cur);
            String[] files = cur.list();
            for (int i = 0; i < files.length; i++) {
                System.out.println((i + 1) + ". " + files[i]);
            }
            do {
                System.out.println("Give file name: ");
                String s = System.getProperty("file.separator");
                String tiedosto = Input.line();
                tiedosto = cur + s + tiedosto;
                f = new File(tiedosto);
                if (!f.exists()) {
                    System.out.println("File " + f + " does not exists!");
                }
            } while (!f.exists());

        }
        // here f exists
        setBufferedReader(f);
        this.file = f;
        return f;
    }

    public String readNext() {            
            
        	/* example:    http://snippets.dzone.com/posts/show/371
        	 *         BufferedReader in = new BufferedReader(new FileReader("file"));
        	            while( (s = in.readLine()) != null) {
        	            		
        	            	String UTF8Str = new String(s.getBytes(),"UTF-8"));
        	            }
        	            
        	            better solution: Reader in = new InputStreamReader(new FileInputStream("file"), "UTF-8"));

        	*/
    	
        String rivi = "";
//        String encoding = "UTF-8"; // get encoding here
//        encoding = ""; // default platform encoding

         String encoding = (String) Find.jComboBox1.getSelectedItem();
//        System.out.println("encoding: " + encoding);
        /*
         * US-ASCII 	Seven-bit ASCII, a.k.a. ISO646-US, a.k.a. the Basic Latin block of the Unicode character set
		 * ISO-8859-1   	ISO Latin Alphabet No. 1, a.k.a. ISO-LATIN-1
		 * UTF-8 	Eight-bit UCS Transformation Format
		 * UTF-16BE 	Sixteen-bit UCS Transformation Format, big-endian byte order
		 * UTF-16LE 	Sixteen-bit UCS Transformation Format, little-endian byte order
		 * UTF-16 	Sixteen-bit UCS Transformation Format, byte order identified by an optional byte-order mark
         */
        try {
            rivi = luettava.readLine();
            if (rivi == null) {
                luettava.close();
            }else{
            	if (!encoding.equalsIgnoreCase("default")){
            		rivi = new String(rivi.getBytes(),encoding);
                }
            }
            
        } catch (FileNotFoundException nfe) {
            System.out.println("File " + this.file + " does not exists.");
        } catch (Exception e) {
            System.out.println("File " + this.file + " Unrecognizable reading error " + e);
            if (WalkFiles.printFirstStack) {
                WalkFiles.printFirstStack = false;
                e.printStackTrace();
            }
        }
        return rivi;
    }

    public void close() {
        try {
            luettava.close();
        } catch (FileNotFoundException nfe) {
            System.out.println("File " + this.file + " does not exists.");
        } catch (Exception e) {
            System.out.println("Unrecognizable error " + e);
            e.printStackTrace();
        }
    }
}
