/**
 * 
 */
package find;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.PrintWriter;

import javax.swing.JFileChooser;

/**
 * @author Veikko Niemi 10.12.2008 6.37.23
 */
public class WriteFile {

    private PrintWriter tulostus;
    private StringBuffer buf = new StringBuffer();
    private File file;
    private static String s = System.getProperty("file.separator");
    private static String l = System.getProperty("line.separator");

    public WriteFile() {
        setFile(new File(""));
    }

    public WriteFile(File file) {
        setFile(file);
    }

    public WriteFile(WriteFile kT) {
        this.tulostus = kT.tulostus;
        this.buf = kT.buf;
        this.file = kT.file;
    }

    private void setFile(File file) {
        boolean ok = false;
        File cur;
        JFileChooser jfc = new JFileChooser();
        do {
            do {
                cur = file;
                if (cur == null || cur.toString().isEmpty()) {
                    cur = askFile(cur);
                }
                if (cur.isDirectory()) {
                    jfc.setCurrentDirectory(cur);
                    System.out.println("Oletushakemisto " + cur);
                    String[] files = cur.list();
                    for (int i = 0; i < files.length; i++) {
                        System.out.println((i + 1) + ". " + files[i]);
                    }
                    file = askFile(cur);
                    if (file.exists() && !file.canWrite()) {
                        System.out.println("Tiedostoon " + file + " ei voi kirjoittaa!");
                    }
                }
            } while (file.exists() && !file.canWrite());
            // here file exists and it can be written or
            // it does not exists

            try {
                tulostus = new PrintWriter(new FileWriter(file));
                ok = true;
            } catch (Exception e) {
                System.out.println(e.getMessage());
            }
        } while (!ok);
    }

    private File askFile(File cur) {
        String tiedosto;
        String vastaus;
        do {
            System.out.println("Give input file name: ");
            tiedosto = Input.line();
            String[] exts = tiedosto.split("[.]");
            String ext = "";
            if (exts.length > 1) {
                ext = exts[exts.length - 1];
            }
            if (!ext.equalsIgnoreCase("txt")) {
                tiedosto += ".txt";
                System.out.println("Changed " + tiedosto);
            }
            tiedosto = cur + s + tiedosto;
            file = new File(tiedosto);
            if (file.exists()) {
                do {
                    vastaus = Input.line("File " + file + " already exists,\n overwrite(y/n)? ");
                } while (vastaus.isEmpty() || !(vastaus.equalsIgnoreCase("y") || vastaus.equalsIgnoreCase("n")));
            } else {
                vastaus = "";
            }
        } while (vastaus.equalsIgnoreCase("n"));
        return file;
    }

    public void writeLine(String rivi) {
        if (!rivi.isEmpty()) {
            buf.append(rivi + l);
        }
    }

    public void closeFile() {
        String kaikki = buf.toString();
        tulostus.print(kaikki);
        tulostus.flush();
        tulostus.close();
    }
}
